import { Db, NgramIndice, SimpleIndice, TextLexIndice } from "cdn-static-database";
import { ISharedIndice } from "cdn-static-database/types/@types/indice";
export { log } from "cdn-static-database";
export declare const restore: (id: string, dbId: string) => Promise<ISharedIndice<any, any>>;
export declare enum Engine {
    "n-gram" = "n-gram",
    "simple" = "simple",
    "text-lex" = "text-lex"
}
export interface ISerializedIndice extends Record<string, unknown> {
    id: string;
    columns?: string[];
    column?: string;
    type?: Engine;
}
export declare const getIndice: (indice: Partial<ISerializedIndice>) => NgramIndice<unknown> | TextLexIndice<unknown> | SimpleIndice<unknown, unknown>;
export declare const getLazyIndice: (indice: Partial<ISerializedIndice>) => typeof NgramIndice.deserialize | typeof SimpleIndice.deserialize | typeof TextLexIndice.deserialize;
export declare const restoreDb: (id: string) => Promise<Db>;
export declare const useFullTextCursorStatelessQuery: <T extends never>(dbId: string, text: string, skip?: number, limit?: number) => {
    next: () => Promise<T[]>;
    hasNext: () => Promise<boolean>;
    finish: () => Promise<void>;
};
export declare const useFullTextCursorStateFullQuery: <T extends never>(dbId: string, text: string, skip?: number, limit?: number) => {
    next: () => Promise<void>;
    finish: () => Promise<void>;
    hasNext: boolean;
    page: T[];
    all: T[];
    fetching: boolean;
};
export declare const useCdnCursorQuery: <T extends never>(dbId: string, query: {
    [name: string]: never;
}, sort: {
    [name: string]: never;
}, skip?: number, limit?: number) => {
    next: () => Promise<T[]>;
    hasNext: () => Promise<boolean>;
    finish: () => Promise<void>;
};
export declare const useCdnCursorStatelessQuery: <T extends never>(dbId: string, query: {
    [name: string]: never;
}, sort: {
    [name: string]: never;
}, skip?: number, limit?: number) => {
    next: () => Promise<T[]>;
    hasNext: () => Promise<boolean>;
    finish: () => Promise<void>;
};
export declare const useCdnCursorStatefulQuery: <T extends never>(dbId: string, query: {
    [name: string]: never;
}, sort: {
    [name: string]: never;
}, skip?: number, limit?: number) => {
    next: () => Promise<void>;
    finish: () => Promise<void>;
    hasNext: boolean;
    page: T[];
    all: T[];
    fetching: boolean;
};
//# sourceMappingURL=index.d.ts.map