"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCdnCursorStatefulQuery = exports.useCdnCursorStatelessQuery = exports.useCdnCursorQuery = exports.useFullTextCursorStateFullQuery = exports.useFullTextCursorStatelessQuery = exports.restoreDb = exports.getLazyIndice = exports.getIndice = exports.Engine = exports.restore = exports.log = void 0;
var cdn_static_database_1 = require("cdn-static-database");
var react_1 = require("react");
var cdn_static_database_2 = require("cdn-static-database");
Object.defineProperty(exports, "log", { enumerable: true, get: function () { return cdn_static_database_2.log; } });
var baseUrl = '/cdn-indice/';
var restore = function (id, dbId) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, cdn_static_database_1.restoreSharedIndicesBrowser({
                id: id,
                baseUrl: "/cdn-indice/" + dbId,
                deserializeShared: cdn_static_database_1.RangeLinearIndice.lazy,
                deserialize: cdn_static_database_1.NgramIndice.deserialize
            })];
    });
}); };
exports.restore = restore;
var Engine;
(function (Engine) {
    Engine["n-gram"] = "n-gram";
    Engine["simple"] = "simple";
    Engine["text-lex"] = "text-lex";
})(Engine = exports.Engine || (exports.Engine = {}));
;
var getIndice = function (indice) {
    var _a = indice.type, type = _a === void 0 ? "simple" : _a, column = indice.column, columns = indice.columns, options = __rest(indice, ["type", "column", "columns"]);
    if (type === "n-gram") {
        return new cdn_static_database_1.NgramIndice(options);
    }
    if (type === "text-lex") {
        return new cdn_static_database_1.TextLexIndice(options);
    }
    if (type === "simple") {
        return new cdn_static_database_1.SimpleIndice(options);
    }
    throw new Error("Engine " + type + " not found");
};
exports.getIndice = getIndice;
var getLazyIndice = function (indice) {
    var _a = indice.type, type = _a === void 0 ? "simple" : _a;
    if (type === "n-gram") {
        return cdn_static_database_1.NgramIndice.deserialize;
    }
    if (type === "simple") {
        return cdn_static_database_1.SimpleIndice.deserialize;
    }
    if (type === "text-lex") {
        return cdn_static_database_1.TextLexIndice.deserialize;
    }
    throw new Error("Engine " + type + " not found");
};
exports.getLazyIndice = getLazyIndice;
var getIndicePath = function (indice) {
    var _a = indice.type, type = _a === void 0 ? "simple" : _a, column = indice.column;
    if (column && type === "simple") {
        return column;
    }
    else {
        return "$" + indice.id;
    }
};
var restoreDb = function (id) { return __awaiter(void 0, void 0, void 0, function () {
    var response, res, indiceInstances, primary, indiceInstancesMap;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, fetch("" + baseUrl + id + "/indices." + id + ".json", {
                    method: 'GET',
                    credentials: 'include',
                    mode: 'no-cors',
                })];
            case 1:
                response = _a.sent();
                return [4 /*yield*/, response.json()];
            case 2:
                res = _a.sent();
                return [4 /*yield*/, Promise.all(__spreadArray([
                        cdn_static_database_1.restoreSharedIndicesBrowser({
                            id: "data." + id,
                            baseUrl: "/cdn-indice/" + id,
                            deserializeShared: cdn_static_database_1.RangeLinearIndice.lazy,
                            deserialize: cdn_static_database_1.SimpleIndice.deserialize
                        })
                    ], __read(res.indices.map(function (indice) { return cdn_static_database_1.restoreSharedIndicesBrowser({
                        id: indice.id,
                        baseUrl: "/cdn-indice/" + id,
                        deserializeShared: cdn_static_database_1.RangeLinearIndice.lazy,
                        deserialize: exports.getLazyIndice(indice)
                    }); }))))];
            case 3:
                indiceInstances = _a.sent();
                primary = indiceInstances.shift();
                indiceInstancesMap = new Map(indiceInstances.map(function (indice) { return ([indice.id, indice]); }));
                return [2 /*return*/, new cdn_static_database_1.Db(new cdn_static_database_1.Schema(res.idAttr, primary, res.indices
                        .map(function (indice) {
                        return ({ indice: indiceInstancesMap.get(indice.id), path: getIndicePath(indice) });
                    })))];
        }
    });
}); };
exports.restoreDb = restoreDb;
var useFullTextCursorStatelessQuery = function (dbId, text, skip, limit) {
    if (skip === void 0) { skip = 0; }
    if (limit === void 0) { limit = 30; }
    var $db = react_1.useMemo(function () { return (function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.restoreDb(dbId)];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); })(); }, [dbId]);
    var cursorCreator = function ($cursor) { return ({
        next: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        return [4 /*yield*/, c.next()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); },
        hasNext: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        return [4 /*yield*/, c.hasNext()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); },
        finish: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        c.finish();
                        return [2 /*return*/];
                }
            });
        }); }
    }); };
    var cursor = react_1.useMemo(function () { return cursorCreator((function () { return __awaiter(void 0, void 0, void 0, function () {
        var db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $db];
                case 1:
                    db = _a.sent();
                    return [2 /*return*/, db.cursorText(text, skip, limit)];
            }
        });
    }); })()); }, [text, skip, limit, dbId]);
    react_1.useEffect(function () {
        return function () {
            (function () { return __awaiter(void 0, void 0, void 0, function () {
                var e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!cursor) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, cursor.finish()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            console.error(e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); })();
        };
    }, [text, skip, limit, dbId]);
    return cursor;
};
exports.useFullTextCursorStatelessQuery = useFullTextCursorStatelessQuery;
var useFullTextCursorStateFullQuery = function (dbId, text, skip, limit) {
    if (skip === void 0) { skip = 0; }
    if (limit === void 0) { limit = 30; }
    var $db = react_1.useMemo(function () { return (function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.restoreDb(dbId)];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); })(); }, [dbId]);
    var _a = __read(react_1.useState({ page: [], all: [], fetching: false, hasNext: false }), 2), state = _a[0], setState = _a[1];
    var cursorCreator = function ($cursor) {
        var p = [];
        var a = [];
        return ({
            next: function () { return __awaiter(void 0, void 0, void 0, function () {
                var c, e_2, h;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            setState(__assign(__assign({}, state), { fetching: true, hasNext: false }));
                            return [4 /*yield*/, $cursor];
                        case 1:
                            c = _a.sent();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, c.next()];
                        case 3:
                            p = _a.sent();
                            a.push.apply(a, __spreadArray([], __read(p)));
                            return [3 /*break*/, 5];
                        case 4:
                            e_2 = _a.sent();
                            return [3 /*break*/, 5];
                        case 5: return [4 /*yield*/, c.hasNext()];
                        case 6:
                            h = _a.sent();
                            setState({ page: p, all: a, fetching: false, hasNext: h });
                            return [2 /*return*/];
                    }
                });
            }); },
            finish: function () { return __awaiter(void 0, void 0, void 0, function () {
                var c;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, $cursor];
                        case 1:
                            c = _a.sent();
                            c.finish();
                            return [2 /*return*/];
                    }
                });
            }); }
        });
    };
    var cursor = react_1.useMemo(function () { return cursorCreator((function () { return __awaiter(void 0, void 0, void 0, function () {
        var db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $db];
                case 1:
                    db = _a.sent();
                    return [2 /*return*/, db.cursorText(text, skip, limit)];
            }
        });
    }); })()); }, [text, skip, limit, dbId]);
    react_1.useEffect(function () {
        cursor.next().catch(function (e) {
            cdn_static_database_1.log.error(e);
        });
        return function () {
            (function () { return __awaiter(void 0, void 0, void 0, function () {
                var e_3;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!cursor) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, cursor.finish()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_3 = _a.sent();
                            cdn_static_database_1.log.error(e_3);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); })();
        };
    }, [text, skip, limit, dbId]);
    return __assign(__assign({}, cursor), state);
};
exports.useFullTextCursorStateFullQuery = useFullTextCursorStateFullQuery;
var useCdnCursorQuery = function (dbId, query, sort, skip, limit) {
    if (skip === void 0) { skip = 0; }
    if (limit === void 0) { limit = 30; }
    var $db = react_1.useMemo(function () { return (function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.restoreDb(dbId)];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); })(); }, [dbId]);
    var cursorCreator = function ($cursor) { return ({
        next: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        return [4 /*yield*/, c.next()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); },
        hasNext: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        return [4 /*yield*/, c.hasNext()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); },
        finish: function () { return __awaiter(void 0, void 0, void 0, function () {
            var c;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, $cursor];
                    case 1:
                        c = _a.sent();
                        c.finish();
                        return [2 /*return*/];
                }
            });
        }); }
    }); };
    var cursor = react_1.useMemo(function () { return cursorCreator((function () { return __awaiter(void 0, void 0, void 0, function () {
        var db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $db];
                case 1:
                    db = _a.sent();
                    return [2 /*return*/, db.cursor(query, sort, skip, limit)];
            }
        });
    }); })()); }, [query, sort, skip, limit, dbId]);
    react_1.useEffect(function () {
        return function () {
            (function () { return __awaiter(void 0, void 0, void 0, function () {
                var e_4;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!cursor) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, cursor.finish()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_4 = _a.sent();
                            console.error(e_4);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); })();
        };
    }, [query, sort, skip, limit, dbId]);
    return cursor;
};
exports.useCdnCursorQuery = useCdnCursorQuery;
exports.useCdnCursorStatelessQuery = exports.useCdnCursorQuery;
var useCdnCursorStatefulQuery = function (dbId, query, sort, skip, limit) {
    if (skip === void 0) { skip = 0; }
    if (limit === void 0) { limit = 30; }
    var $db = react_1.useMemo(function () { return (function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, exports.restoreDb(dbId)];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); })(); }, [dbId]);
    var _a = __read(react_1.useState({ page: [], all: [], fetching: false, hasNext: false }), 2), state = _a[0], setState = _a[1];
    var cursorCreator = function ($cursor) {
        var p = [];
        var a = [];
        return ({
            next: function () { return __awaiter(void 0, void 0, void 0, function () {
                var c, e_5, h;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            setState(__assign(__assign({}, state), { fetching: true, hasNext: false }));
                            return [4 /*yield*/, $cursor];
                        case 1:
                            c = _a.sent();
                            _a.label = 2;
                        case 2:
                            _a.trys.push([2, 4, , 5]);
                            return [4 /*yield*/, c.next()];
                        case 3:
                            p = _a.sent();
                            a.push.apply(a, __spreadArray([], __read(p)));
                            return [3 /*break*/, 5];
                        case 4:
                            e_5 = _a.sent();
                            cdn_static_database_1.log.trace(e_5);
                            return [3 /*break*/, 5];
                        case 5: return [4 /*yield*/, c.hasNext()];
                        case 6:
                            h = _a.sent();
                            setState({ page: p, all: a, fetching: false, hasNext: h });
                            return [2 /*return*/];
                    }
                });
            }); },
            finish: function () { return __awaiter(void 0, void 0, void 0, function () {
                var c;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, $cursor];
                        case 1:
                            c = _a.sent();
                            c.finish();
                            return [2 /*return*/];
                    }
                });
            }); }
        });
    };
    var cursor = react_1.useMemo(function () { return cursorCreator((function () { return __awaiter(void 0, void 0, void 0, function () {
        var db;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $db];
                case 1:
                    db = _a.sent();
                    return [2 /*return*/, db.cursor(query, sort, skip, limit)];
            }
        });
    }); })()); }, [query, sort, skip, limit, dbId]);
    react_1.useEffect(function () {
        cursor.next().catch(function (e) {
            cdn_static_database_1.log.error(e);
        });
        return function () {
            (function () { return __awaiter(void 0, void 0, void 0, function () {
                var e_6;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!cursor) return [3 /*break*/, 4];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, cursor.finish()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_6 = _a.sent();
                            cdn_static_database_1.log.error(e_6);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            }); })();
        };
    }, [query, sort, skip, limit, dbId]);
    return __assign(__assign({}, cursor), state);
};
exports.useCdnCursorStatefulQuery = useCdnCursorStatefulQuery;
//# sourceMappingURL=index.js.map